/*

PSS header file

*/




#define  MAX_CONCURRENT_USERS    10
#define  MAX_CONCURRENT_JOBS     15


#define  NUM_RX_ECBS       MAX_CONCURRENT_USERS
#define  NUM_TX_ECBS       MAX_CONCURRENT_USERS

#define  PJOB_SERVICE_LEN     4096
#define  NUM_BUFF_PTRS        10










#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <dos.h>
#include <io.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <limits.h>
#include <direct.h>
#include <process.h>
#include <conio.h>
#include <ctype.h>



#include "common.h"





typedef struct oConnect {
   BOOL     Online;

   WORD     nBytesRead,nBytes2Read;
   WORD     nBytesSent,nBytes2Send;

   WORD     state,mode;

   BYTE     data[ UPGBUFFLEN ];

   TLIINT   socket;
   FILE     *inf;

} UPGCONN, far * LPCONN;









typedef struct oClient {
   WORD        lastSerial,port;
   WORD        lTimeout,sessionCode;
   BOOL        jobDead,isQueueing;
   DWORD       len;
   BYTE        fname[20];
   FILE        *outf;
   IPXAddress  src;

   void far * nxt;

} CDEF, far * LPCDEF;



typedef struct oBuff {
   LPCDEF   client;
   WORD     len;
   BYTE     data[ NBLEN_CMD - sizeof(CMD) ];

   void far * nxt;

} BUFF, far * LPBUFF;





typedef struct oJob {
   WORD        port;
   BYTE        fname[20];
   DWORD       len;
   IPXAddress  src;

   void far *  nxt;

} PJOB, far * LPJOB;




typedef struct oPort {
   BYTE     name[10];
   LPBYTE   readBuf;
   WORD     nBytes2Send, nBytesSent;

   BOOL     portErr;
   WORD     pData,pStatus;

   DWORD    cBytes,tBytes, nBytesQueued;

   FILE     *inf;
   PJOB     curJob;

   WORD     nJobsServiced, nJobsInQueue,nJobsLoading;
   LPJOB    jqTop, jqBottom;
} PDEF, far * LPPDEF;





typedef struct oGlobals {

   WORD        upgServerType;
   BYTE        upgServerName[50];
   WORD        upgServerSocket;

   TLIINT      upgfd;
   UPGCONN     upgConnects[ NUM_UPGCONNECTS ];


   BOOL        useBIOS;

   WORD        timeBase,qfNum,sessionCode,timeDisp;

   IPXAddress  addrMe;
   ECB         ecbTimer;

   LPPDEF      ports;
   LPCDEF      clients;
   LPJOB       jobs;
   LPBUFF      buffs[ NUM_BUFF_PTRS ];

   LPCDEF      cqTop, clientsFree;
   LPBUFF      bqTop, bqBottom, buffsFree;
   LPJOB       jobsFree;

   WORD        usedClients,usedJobs,usedBuffs;
   WORD        numClients,numJobs,numBuffs;

   LPECB       ecbFree;

   ECB         ecbRx[ NUM_RX_ECBS ];
   ECB         ecbTx[ NUM_TX_ECBS ];

   IPXHeader   hdrRx[ NUM_RX_ECBS ];
   IPXHeader   hdrTx[ NUM_TX_ECBS ];

   LPBYTE      dataRx[ NUM_RX_ECBS][NBLEN_CMD];
   LPBYTE      dataTx[ NUM_TX_ECBS][NBLEN_ACK];

} GLOBALS, far * LPGLOBALS;








extern void upgCheck(void);
extern int  upgSetup(void);
extern int  upgShutdown(void);

extern LPGLOBALS   gl;




/* eof, pss.h */

